/******************************************************************************/
//  Version: 0.0.8
/******************************************************************************/

/************************************************************************************************************************/
// variables
var dropArea = document.getElementById('wp_hb_rsl_dropArea');
var canvas = document.querySelector('canvas');
var context = canvas.getContext('2d');
var count = document.getElementById('wp_hb_rsl_count');
var destinationUrl = document.getElementById('wp_hb_rsl_url');
var destinationUrl_del = destinationUrl.value+"wp-hb-ajax-loeschen.php";
var destinationUrl_upl = destinationUrl.value+"wp-hb-ajax-upload.php";
// var result = document.getElementById('wp_hb_rsl_result');
var list = [];
var totalSize = 0;
var totalProgress = 0;
/************************************************************************************************************************/

    // init handlers
    function initHandlers() {
        dropArea.addEventListener('drop', handleDrop, false);
		dropArea.addEventListener('dragover', handleDragOver, false);
		dropArea.addEventListener('dragleave', handleDragLeave, false);
    }
	
	

	/* Funktion für den klassischen Upload (auch mobile Geräte */
	function wp_fb_prepareUpload(event)  {
		
    	files = event.target.files;
		
	  	jQuery('#wp_hb_rsl_meldunguplaod').hide();
		jQuery('#wp_hb_rsl_canvas').show();
		jQuery('#wp_hb_rsl_zaehler').show();
        processFiles(files);    
  	}
	
	
    // draw progress
    function drawProgress(progress) {
        context.clearRect(0, 0, canvas.width, canvas.height); // clear context

        context.beginPath();
        context.strokeStyle = '#4B9500';
        context.fillStyle = '#4B9500';
        context.fillRect(0, 0, progress * 500, 20);
        context.closePath();

        // draw progress (as text)
        context.font = '16px Verdana';
        context.fillStyle = '#000';
        context.fillText('Progress: ' + Math.floor(progress*100) + '%', 50, 15);
    }

    // drag over
    function handleDragOver(event) {
        event.stopPropagation();
        event.preventDefault();
        dropArea.className = 'hover';
    }
	// dragleave
	function handleDragLeave(event) {
        event.stopPropagation();
        event.preventDefault();		
        dropArea.classList.remove("hover");
    }
    // drag drop
    function handleDrop(event) {
        event.stopPropagation();
        event.preventDefault();
		jQuery('#wp_hb_rsl_meldunguplaod').hide();
		jQuery('#wp_hb_rsl_canvas').show();
		jQuery('#wp_hb_rsl_zaehler').show();
		
        processFiles(event.dataTransfer.files);
    }

    // process bunch of files
    function processFiles(filelist) {
        if (!filelist || !filelist.length || list.length) {
			
			return;
		}
        totalSize = 0;
        totalProgress = 0;
        
		var maxsize = 1204*1024*8 // max 8MB
        for (var i = 0; i < filelist.length && i < 50; i++) {
			var fname = filelist[i]['name'];
			var end = fname.substr(fname.length - 3)
            var endung = end.toLowerCase()
            var aendung = endung.match(/\bcsv\b|\bpdf\b|\btif\b|\bgif\b|\bjpg\b|\bpng\b|\bsvg\b|\bdoc\b|\bxls\b|\blsx\b|\bocx\b/)
            if( aendung ){				
				if (filelist[i]['size'] >= maxsize) { 
					result.innerHTML += '<div class="f">'+fname+' ist zu groß um hochgeladen zu werden.</div>';
					handleComplete(nextFile.size);
				}else{ 
					list.push(filelist[i]);
					totalSize += filelist[i].size;
				}
			}else{
				jQuery('#wp_fb_uploadliste').append(fname+" nicht erlaubt.<br>")
				result.innerHTML += '<div class="f"><p>'+fname+' nicht erlaubter Dateityp.</p><p>Datei wurde nicht hochgeladen.</p></div>';
			}			
        }
        uploadNext();
    }

    // on complete - start next file
    function handleComplete(size) {
        totalProgress += size;
        drawProgress(totalProgress / totalSize);
        uploadNext();
    }

    // update progress
    function handleProgress(event) {
        var progress = totalProgress + event.loaded;
        drawProgress(progress / totalSize);
    }

    // upload file
    function uploadFile(file, status) {

        // prepare XMLHttpRequest
        var xhr = new XMLHttpRequest();
		// console.log(destinationUrl_upl)
        xhr.open('POST', destinationUrl_upl);
        xhr.onload = function() {
			
			wp_nachbehandlung(this.responseText);
            handleComplete(file.size);
        };
        xhr.onerror = function() {
            result.textContent = this.responseText;
            handleComplete(file.size);
        };
        xhr.upload.onprogress = function(event) {
            handleProgress(event);
        }
        xhr.upload.onloadstart = function(event) {
        }

        // prepare FormData
        var formData = new FormData();  
		var pfad = jQuery('#wp_hb_rsl_pfad').val();
        formData.append('myfile', file); 
		formData.append('mypfad', pfad); 
		formData.append('vorname',  jQuery('#wp_hb_rsl_vorname' ).val()); 
		formData.append('nachname', jQuery('#wp_hb_rsl_nachname').val()); 		
        xhr.send(formData);
    }

    // upload next file
    function uploadNext() {
        if (list.length) {
            count.textContent = list.length - 1;
            dropArea.className = 'uploading';
			var nextFile = list.shift();				
            uploadFile(nextFile, status);
        } else {
            dropArea.className = '';
			jQuery('#wp_hb_rsl_meldunguplaod').show();
			jQuery('#wp_hb_rsl_canvas').hide();
			jQuery('#wp_hb_rsl_zaehler').hide();
			
        }
    }
	
	function wp_nachbehandlung(json){
		
		result = jQuery.parseJSON(json);
		// console.log(result);
		jQuery('#wp_hb_rsl_result').append(result.dasNeue);
		var sliderid  = result.unterverzeichnis;
		var sliderbild = result.datei;
		var sliderbild_url = result.datei_url;
		// Aktualisierung der Sliderdatenbank
		wp_hb_rsl_slider_update_db(sliderid, sliderbild, sliderbild_url, "neues_sliderbild",null);	
		var wp_hb_focussiere = '#b:'+result.datei;
		console.log(wp_hb_focussiere);
		jQuery(wp_hb_focussiere).focus()
		jQuery(wp_hb_focussiere).hide(800).show(800);
 		initAktion();
	}
	
	/***********************************************************************/
	function wp_hb_rsl_loeschedatei(deldatei){

		var pfad = jQuery('#wp_hb_rsl_pfad').val();
		var sliderid  = pfad;
		var sliderbild = deldatei;
		var sliderbild_url = "";
		wp_hb_rsl_slider_update_db(sliderid, sliderbild, sliderbild_url, "loesche_sliderbild",null);
		
		ajaxData = '?e?aktion=loesche_pdfbild&pfad='+pfad+'&datei='+deldatei;
		// console.log(destinationUrl_del+ajaxData);
		jQuery.getJSON(destinationUrl_del, ajaxData, function(json){
			// console.log(json);
		});
		
	}
	/***********************************************************************/
	function wp_hb_rsl_updatebemerkung(bdatei,wert){
		var pfad = jQuery('#wp_hb_rsl_pfad').val();
		var sliderid  = pfad;
		var sliderbild = bdatei;
		var sliderbild_url = "";
		
		wp_hb_rsl_slider_update_db(sliderid, sliderbild, sliderbild_url, "update_bemerkung",wert);
	}
	/***********************************************************************/
	function wp_hb_rsl_updatereihenfolge(rdatei,wert){	
console.log(rdatei)	;
		var pfad = jQuery('#wp_hb_rsl_pfad').val();
		var sliderid  = pfad;
		var sliderbild = rdatei;
		var sliderbild_url = "";
		wp_hb_rsl_slider_update_db(sliderid, sliderbild, sliderbild_url, "update_reihenfolge",wert);
		
		
	}
	
/************************************************************************************************************************/
/************************************************************************************************************************/
/************************************************************************************************************************/
	



	jQuery(document).ready(function(){
		initHandlers();
		initAktion();
		
	});
