<?php
/*
* Plugin Name: Responsitiver Slider
* Description: A simple responsitiv sliderplugin.
* Plugin URI: https://brinkmann.ksc-lemgo.de/responsitiver-slider/
* Domain Path: /sprachen
* Version: 1.0.1
* Author: Hubertus Brinkmann 
* Author URI: https://brinkmann.ksc-lemgo.de
* License: GPL2
*/

/*  Copyright 2018  Hubertus Brinkmann  (email : Hubertus.Brinkmann@ksc-lemgo.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//  define constants

define('RSL_VERSION', '1.0.1');
define('RSL_db_version', '0.0.7');
define('RSL_PLUGINDIR',plugins_url('',__FILE__)."/" );
define('RSL_TEXTDOMAIN','sprachen/wp-hsettings
b-slider');
define('RSL_TEXTDOMAIN','sprachen/wp-hb-slider');
add_action('plugins_loaded', 'rsl_init');

if( !get_option('RSL_author')) {
	$RSL_author = "edit_posts";
	add_option("RSL_author", $RSL_author);
}

/********************* register the HOOCKS **********************/
// wird ausgeführt wenn das Plugin aktiviert wird.
	 register_activation_hook( __FILE__,   'TinyMCE_RSL_GALERIE_activate' ) ;
// Hier wurde die editor-style.css bearbeitet und das slidericon in das Themeverzeichnis kopiert.
// und der folgende wenn das Plugin deaktiviert wird.
	 register_deactivation_hook(__FILE__,   'TinyMCE_RSL_GALERIE_deactivate' );
// Löschen der Einträge in der eidtor-style.css und löschend der Slidericondateien.		
// Wenn wir im ADMIN-Bereich sind wird das Setup durchlaufen
		if ( is_admin() ) {
			add_action( 'init', 'rsl_setup_tinymce_plugin'  );
			wp_enqueue_style('rsl-styling', RSL_PLUGINDIR .'css/wp-hb-slider-admin-style.css', false, RSL_VERSION, "all");
			
			
		} 	
// Bis hier die Hooks für den TinyMCE		

// Setting the stylesheet for the adminarea:
if(isset($_REQUEST['page'])) {
  if($_REQUEST['page']=='wordpress-slider' || $_REQUEST['page']=='wordpress-slider-settings')  {
    add_action( 'admin_init', 'rsl_admin_head' );
    function rsl_admin_head() {
      	  
    }
  }
}

/*********************************************************************/
// hier initialisierung de shortcodes
/*********************************************************************/
// do_shortcode( $tag , $func );
add_shortcode('wp-hb-slider','wp_hb_slider_func' );



// Style einbinden

wp_enqueue_style('rsl-styling-slippry', RSL_PLUGINDIR .'css/slippry.css', false, RSL_VERSION, "all");

// wp_enqueue_style('rsl-styling-simplyscroll', RSL_PLUGINDIR .'css/simplyscroll.css', false, RSL_VERSION, "all");

// Die Javascripte einbinden
add_action( 'admin_enqueue_scripts', 'RSL_admin_scripts' );

// Einbinder der javascripts für das Frontend

add_action( 'wp_enqueue_scripts', 'RSL_frontend_scripts' );


// sind die Datenbanken aktuell?
add_action('plugins_loaded', 'RSL_update');
// die Serverseitigen Ajaxfunctionen bekannt machen.
add_action( 'wp_ajax_wp_hb_slider_serversidefunction', 'wp_hb_slider_serversidefunction' );

// Create the admin menu to call the side
add_action( 'admin_menu', 'RSL_menu');

// create the database only when Plugin is acivated.
register_activation_hook(__FILE__,'RSL_install');

function RSL_frontend_scripts(){
	if (!is_admin()) {
		$in_footer = false; // false ist der davault Wert 
		$ver = '1.4.0';
		$src = RSL_PLUGINDIR . 'js/slippry.js'; // 	Full URL of the script
		wp_enqueue_script('slippry', $src, 'jquery', $ver, $in_footer);		
		$ver = '1.6.4';
		$src = RSL_PLUGINDIR . 'js/jquery.colorbox-min.js'; // 	Full URL of the script
		wp_enqueue_script('colorbox', $src, 'jquery', $ver, $in_footer);	
		
		$deps = array('jquery','slipry_slider','colorbox');
		$src = RSL_PLUGINDIR . 'js/wp-hb-slider-frontend.js'; 		
		wp_enqueue_script('wp_hb_slider_frontend', $src,  'jquery', RSL_VERSION, $in_footer);	
	
		wp_enqueue_style('wp-hb-slider', RSL_PLUGINDIR .'css/wp-hb-slider.css', false, RSL_VERSION, "all");
		wp_enqueue_style('wp-hb-colorbox', RSL_PLUGINDIR .'css/cb1/colorbox.css', false, RSL_VERSION, "all");

	}
}

function RSL_admin_scripts() {  
	//wp_enqueue_script( $handle        , $src , $deps = array(), $ver = false, $in_footer = false )	
	$src = RSL_PLUGINDIR . 'js/wp-hb-slider-admin.js'; // 	Full URL of the script
	$in_footer = true; // false ist der davault Wert 
	wp_enqueue_script('wp_hb_slider_admin', $src, '', RSL_VERSION, $in_footer);
	
	
	wp_localize_script( 'wp_hb_slider_admin', 'wp_hb_slider_ajaxdaten', array(
				'ajaxurl' => admin_url( 'admin-ajax.php' ),   // die muss so übernommen werden.
				'RSL_PLUGINDIR' => RSL_PLUGINDIR,
				'FMG' => __('The form is loadet, please wait.',RSL_TEXTDOMAIN),
				'ueberschrift' => __('Insert the shortcode for the slider.',RSL_TEXTDOMAIN),
				'ueberschrift2' => __('Please choose al slider from the dropdownfield.',RSL_TEXTDOMAIN),
				'input1'  => __('Slider:',RSL_TEXTDOMAIN),
				'input2'  => __('Alignment:',RSL_TEXTDOMAIN),
				'input2a' => __('flush left',RSL_TEXTDOMAIN),
				'input2b' => __('center',RSL_TEXTDOMAIN),
				'input2c' => __('flush right',RSL_TEXTDOMAIN),
				'input3'  => __('Slider type:',RSL_TEXTDOMAIN),
				'input3a' => __('classic slider (horizontal)',RSL_TEXTDOMAIN),
				'input3b' => __('pictures (fade slideshow without overlay)',RSL_TEXTDOMAIN),
				'input3c' => __('pictures (kenburnseffekt)',RSL_TEXTDOMAIN),
				'input3d' => __('all thumbnails, pictures as slideshow',RSL_TEXTDOMAIN),
				'input3e' => __('one thumbnail, pictures as slideshow',RSL_TEXTDOMAIN),
				'input3f' => __('slider with thumbnails',RSL_TEXTDOMAIN),
				'input3g' => __('scrolling (banner)',RSL_TEXTDOMAIN),
				
				'input4' => __('Order (random)',RSL_TEXTDOMAIN),
				'input5' => __('A tick here makes the pictures appear in random order.',RSL_TEXTDOMAIN),
				'input6' => __('Slider width',RSL_TEXTDOMAIN),
				'input7' => __('Slider height',RSL_TEXTDOMAIN),
				'input8' => __('A 0 for width and / or height ensures that this parameter is not set. If only the width is specified, the slider is scaled accordingly.',RSL_TEXTDOMAIN),
				'input9' => __('OK',RSL_TEXTDOMAIN),
				'inputA' => __('Remove',RSL_TEXTDOMAIN),
				'inputB' => __('Cancle',RSL_TEXTDOMAIN),
				 
			)
	);
	
	
}  


// Make plugin available for translation
function rsl_init() {
  load_plugin_textdomain(RSL_TEXTDOMAIN, false, dirname( plugin_basename( __FILE__ ) ) );
  
}
/********************************************************/
// Creating the Table in the DB or updating the structure
/********************************************************/
function RSL_install($echo = 0) {
	global $wpdb;	
    $test = add_option("RSL_db_version", "0.0.0");
	$installed_ver = get_option( "RSL_db_version" );
	if ($echo == 1)
		echo "TEST=".$test." == ".$installed_ver ." -- ".RSL_db_version."<<<<br>";
	
	RSL_update($echo);
}	// End Create Table in DB function
/********************************************************/
function RSL_update($echo = 0) { 
	global $wpdb;
	$table_name = $wpdb->prefix . "wp_hb_slider";
	$installed_ver = get_option( "RSL_db_version" );
	if ($echo == 1)
		echo $installed_ver ." -- ".RSL_db_version."<<<<br>";
	if( $installed_ver != RSL_db_version ) {  
		$sql = "CREATE TABLE $table_name (
			id mediumint(9) NOT NULL AUTO_INCREMENT,
			name VARCHAR(50) NOT NULL,
			schlagworte VARCHAR(255) NOT NULL,
			pfad MEDIUMTEXT NOT NULL,
			titel MEDIUMTEXT NULL,
			pageid bigint(20) NOT NULL, 
			autor bigint(20) NOT NULL,  
			bilder bigint(20) NOT NULL,			
			UNIQUE KEY id (id)
		);";		
  
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		if ($echo == 1)
			echo $sql."<br>";
		dbDelta($sql);
		
		/***********************************************************/
		// Tabelle der Sliderbilder sliderid, sliderbild, sliderbild_url
		$table_name = $wpdb->prefix . "wp_hb_slider_bilder";	
		if ($echo == 1)
			echo $installed_ver ." -- ".RSL_db_version."<<<<br>";
		
		$sql = "CREATE TABLE $table_name (
				bildnummer bigint(20) NOT NULL AUTO_INCREMENT,
				sliderid bigint(20) NOT NULL,
				sliderbild VARCHAR(255) NOT NULL,
				sliderbild_url VARCHAR(255) NOT NULL,				 
				hochgeladenvon bigint(20) NOT NULL, 
				reihenfolge bigint(20) NOT NULL DEFAULT '5000',
				bemerkung VARCHAR(255) NOT NULL,
				zufall bigint(20) NOT NULL,
				UNIQUE KEY bildnummer (bildnummer)
		);";		
  
		if ($echo == 1)
			echo $sql."<br>";
		dbDelta($sql);		
			
        update_option( "RSL_db_version", RSL_db_version );
	}
} 	// End Update Table in DB function


/********************************************************/
/********************************************************/
/********************************************************/
/********************************************************/
// Hier wird der Slider in den shortcode eingebaut
/********************************************************/
/********************************************************/
// [wp-hb-slider sliderid=1 slidertyp=2 width=275px ausrichtung=rechts]
/********************************************************/
/********************************************************/
	function wp_hb_slider_func($argument){
		
		global $wpdb;
		$slidedrtyp = 0;
		
		// Auswahl ders Slidertyps je nach Auswahl wird das entsprechende Initialisierungsprogramm gentzt.
		if ( isset($argument['slidertyp']) )
			$slidedrtyp = $argument['slidertyp'];
		
		// echo '<pre>'; print_r($argument); echo '</pre>';
		
		
		// Als Erstes der Container in den der Slider kommt.
		// dieser wird zu 100%  Breite durch den Slider ausgefüllt.
		$st_w = "";
		$st_h = "";
		$st_a = "";
		// echo '<pre>'; print_r($argument); echo '</pre>';
		/*
		SELECT * FROM `m247c_wp_hb_slider_bilder`  where `sliderid` = 3  ORDER BY zufall, reihenfolge ,bildnummer
		*/
		
			
		$antwort = '<div class="wp_hb_slider_container" ';
		
			if ( isset($argument['width']) ){
				$st_w = 'width: 100%;max-width: '.$argument['width'].'; ';
			}
			if ( isset($argument['height']) ){
				$st_h = 'min-height: '.$argument['height'].'; ';
			}
			if ( isset($argument['ausrichtung']) ){
				if ( "links" == $argument['ausrichtung'] ){
					$st_a = 'float:  left; margin: 0 10px 0 0;';
				}
				if ( "zentriert" == $argument['ausrichtung'] ){
					$st_a = 'margin: 0 auto; ';
				}
				if ( "rechts" == $argument['ausrichtung'] ){
					$st_a = 'float:  right; margin: 0 0 0 10px;';
				}
			}
			
		$antwort .= 'style="'.$st_w.$st_h.$st_a.'"> ';
			
			
		$reihenfolge = ' ORDER BY reihenfolge ASC ,bildnummer ASC ';
		if ( isset($argument['zufallsreihenfolge']) ){
			
			if ($argument['zufallsreihenfolge'] == 1 ){
				zufallsreihenfolge($argument['sliderid']);
				$reihenfolge = ' ORDER BY zufall, reihenfolge ,bildnummer ';
			}
				
		}
		
		// Einlesen der Bilder für die Slideshow.
		$table_name = $wpdb->prefix ."wp_hb_slider_bilder";        
		$sliderid = 2;
		$s_sql  = "SELECT * FROM ".$table_name;
		$s_sql .= ' where `sliderid` = '.$argument[sliderid];
		$s_sql .= $reihenfolge;
        $meine_bilder = $wpdb->get_results($s_sql, "ARRAY_A");
		$anzbilder = count($meine_bilder);     
		if( 0 < $anzbilder ){
			// Wenn Bilder vorhanden sind wird des Slider konfiguriert.
		
			$wp_hb_slidertyp = array('mySliderDefault','mySliderTransition','mySliderPictures','myMiniaturbilder','mySliderThumbnails','mySliderScrollen','mySliderDiashow','mySliderFade');
		
			$DiashowID = mt_rand(100000, 999999);
			$sl = '<div class="'.$wp_hb_slidertyp[$slidedrtyp].'"><ul>';
			$minibild = '<div id="DiashowID_'.$DiashowID.'" class="wp_hb_slider_minibilder_box"> <ul class="wp_hb_slider_minis">';
			$thumbbox = '<div class="wp_hb_slider_thumb_box"> <ul class="wp_hb_slider_thumbs">';
		
			$ds = "";
			$i = 0;
			$us = '';
			$class_unsichtbar = 'class="wp_rsl_unsichtbar "';
			if  ( 'myMiniaturbilder' == $wp_hb_slidertyp[$slidedrtyp] ) 
				$class_unsichtbar = '';

			foreach($meine_bilder as $bild) {
				$len = strlen($datei)-3;
				$sld = substr($datei,3,$len);
				$i ++;
				$sl 		.= '<li> <a href="#slide'.$i.'"><img  '.$us.' src="'.$bild['sliderbild_url'].'/'.$bild['sliderbild'].'" alt="'.$bild['bemerkung'].'" /> </a></li> ';
				$minibild 	.= '<li '.$us.'> <a class="mySliderDiashow" href="'.$bild['sliderbild_url'].'/'.$bild['sliderbild'].'"><img src="'.$bild['sliderbild_url'].'/tn_'.$bild['sliderbild'].'" alt="'.$bild['bemerkung'].'" /> </a></li> ';
				$thumbbox 	.= '<li>         <a href="#'.$i.'" data-slide="'.$i.'"><img  src="'.$bild['sliderbild_url'].'/tn50_'.$bild['sliderbild'].'" alt="'.$bild['bemerkung'].'" /> </a></li> ';
				
				$us = $class_unsichtbar; 
			};
			$sl .= '</ul>';
			$thumbbox .= '</ul>';		
			
			
			switch ($wp_hb_slidertyp[$slidedrtyp]) {
				case 'myMiniaturbilder': // alle als Miniaturbilder	Diashow mit Overlay
						$antwort .= $minibild;	
						$antwort .= '</div>';
					break;
				case 'mySliderThumbnails': // Thumbnails steuern den Slider 
						$antwort .= $sl;
						$antwort .= '</div>';
						$antwort .= $thumbbox;
						$antwort .= '</div>';						
					break;	
				case 'mySliderDiashow': // 1. Bild als Minibild stratet die Diashow (Overlay)
						$antwort .= $minibild;	
						$antwort .= '</div>';
					break;	
				default:
					$antwort .= $sl;
					$antwort .= '</div>';
				
			}
			
			
			
			
			
		}else{
			
			$antwort .='<img src="'.RSL_PLUGINDIR.'css/rsl_icon.png">';
		}
		$antwort .='</div>';
		return $antwort;
	}
/********************************************************/
/********************************************************/
function do_wp_hb_slider_func($shortcode){
	
	$die_argumente = shortcode_parse_atts($shortcode);	
	echo wp_hb_slider_func($die_argumente);
}
/********************************************************/
	function zufallsreihenfolge($sliderid){
		global $wpdb; 
		$zurueck = "";
		$table_name = $wpdb->prefix ."wp_hb_slider_bilder";        
		$s_sql  = "SELECT * FROM ".$table_name;
		$s_sql .= ' where `sliderid` = '.$sliderid;
		$s_sql .= ' ORDER BY reihenfolge ASC ,bildnummer ASC ';
        $meine_bilder = $wpdb->get_results($s_sql, "ARRAY_A");
		$anz_bilder = count($meine_bilder);     
		if( 0 < $anz_bilder){		
			$zaehler= 10;			
			foreach($meine_bilder as $bild) {	
				
				$Slider['zufall'] = mt_rand(100000, 999999);
				$where['bildnummer'] =   $bild['bildnummer'];
				$wpdb->update( $table_name, $Slider, $where );				
				$zaehler = $zaehler + 10;
			}
		}
		return $zurueck;
    }		// Ende function Zufallsreihenfolge
/********************************************************/

/****************************************************************/
// Hier Einbindung der AJAX-Nutzung
/****************************************************************/


function wp_hb_slider_serversidefunction() {
	
	require_once('ajax/wp-hb-slider-ajax.php');
    wp_die();
}
/****************************************************************/
/**** Ende der Ajaxnutzung                         **************/
/****************************************************************/
 
/********************************************************/
	function RSL_menu() {
		$capability  = get_option('RSL_author');
		// $capability = 'upload_files';
		//add_menu_page( $page_title       ,  $menu_title, $capability             , $menu_slug        , callable $function = '', string $icon_url = '', int $position = null )
		add_menu_page('Wordpress Slider' , 'Slider'    ,$capability  , 'wordpress-slider', 'wordpress_slider_seite'          ,RSL_PLUGINDIR.'css/rsl_icon16.png');
		
		// make the link settings in the pluginslist
		add_filter( 'plugin_action_links', 'RSL_link_einstellungen', 10, 2 );
		//optionenseite hinzufügen
		add_options_page('wp-hb-slider-einstellungen', 'Responsitiver Slider', 9, __FILE__, 'RSL_einstellungen'); 
	
		
	}// End function RSL_menu to add a button to the admin dashboard

	function RSL_link_einstellungen($links, $file){

			if ( $file == plugin_basename( __FILE__ ) ) {
				$neuer_links = '<a href="'.get_admin_url().'options-general.php?page=wp-hb-slider/wp-hb-slider.php">'.__('Settings', 'wp-hb-slider').'</a>';
				array_unshift( $links, $neuer_links );
			}
			return $links;
	}
	/********************************************************/
	function RSL_einstellungen(){
		require_once('formulare/wp-hb-slider-einstellungen.php');
	}
	
	/********************************************************/
	// here started the side you call in the adminmenue
	/********************************************************/
	function wordpress_slider_seite() {
	
		/******************************************************************************/
		// her we test the $_POST
		/******************************************************************************/
		$formular = 'slider_verwaltung';
		// echo '<pre>'; print_r($_POST); echo '</pre>';
		if ( isset($_POST['formular'] ) )
			$formular =  $_POST['formular'];
		/******************************************************************************/
		if (!current_user_can(get_option('RSL_author')))  {
			wp_die( __('You do not have sufficient permissions to access this page.',RSL_TEXTDOMAIN) );
		} // end check authorisation level of the user logged in
		$current_user = wp_get_current_user();
		// echo "<pre>current_user";	print_r($current_user);	echo '</pre>';
		/******************************************************************************/
		// echo ' Speichern der Sliderdaten (Neue Slider)';
		/******************************************************************************/
		if(isset($_POST['aktion'])) {
			// echo 'aktion'.$_POST['aktion'];
			if("neuer_slider_anlegen" == $_POST['aktion']) { // Neuen Slider in die Datenabk eintragen
				global $wpdb;            
				$table_name = $wpdb->prefix . "wp_hb_slider";
				$neueSlider['name'] = $_POST['name'];
				$neueSlider['titel'] = $_POST['titel'];
				$neueSlider['autor'] = $current_user->ID;    
				$wpdb->insert( $table_name, $neueSlider );
				$result = $wpdb->insert_id;
			}
			if("slider_aktualisieren" == $_POST['aktion']) { // Datenbank updaten
				global $wpdb;            
				$table_name = $wpdb->prefix . "wp_hb_slider";
				$Slider['name'] = $_POST['name'];
				$Slider['titel'] = $_POST['titel'];
				$Slider['autor'] = $current_user->ID;    
				$where['id'] =  $_POST['slider_welcher'];  
				$wpdb->update( $table_name, $Slider, $where );
				$result = $wpdb->update_id;
			}
			if("slider_loeschen" == $_POST['aktion']) { // Datenbank updaten
				global $wpdb; 
				$zurueck = "";
				$table_name = $wpdb->prefix ."wp_hb_slider_bilder";        
				$s_sql  = "SELECT * FROM ".$table_name;
				$s_sql .= ' where `sliderid` = '.$_POST['slider_welcher'];
				$s_sql .= ' ORDER BY reihenfolge ASC ,bildnummer ASC ';
				$meine_bilder = $wpdb->get_results($s_sql, "ARRAY_A");
				$anz_bilder = count($meine_bilder);     
				$Verzeichnis = $_SERVER["DOCUMENT_ROOT"] .'wp-content/plugins/wp-hb-slider/bilder/'.$_POST['slider_welcher'];
				
				echo $Verzeichnis."<br>";
				if( 0 < $anz_bilder){		
						
					foreach($meine_bilder as $bild) {	
						$tn = $Verzeichnis.'/tn_'.$bild['sliderbild'];
						$tn50 = $Verzeichnis.'/tn50_'.$bild['sliderbild'];
						$tn1200 = $Verzeichnis.'/'.$bild['sliderbild'];
						$Z = unlink($tn);
						$Z = unlink($tn50);
						$Z = unlink($tn1200);
					}
				}
				$lindex = $Verzeichnis.'/index.html';
				$Z = unlink($lindex);
				rmdir($Verzeichnis);
				
				$table_name = $wpdb->prefix . "wp_hb_slider_bilder";
				$sSql = "DELETE FROM ".$table_name;
				$sSql .= " where `sliderid` = ".$_POST['slider_welcher'] ;		
				$result = $wpdb->get_row($sSql);	
				
				$table_name = $wpdb->prefix . "wp_hb_slider";
				$sSql = "DELETE FROM ".$table_name;
				$sSql .= " where `ID` = ".$_POST['slider_welcher'] ;		
				$result = $wpdb->get_row($sSql);	
				
			}
			
			
			
		}
		/******************************************************************************/  
		
		// echo' Überschrift der Seite im Adminbereich';
		echo '<h2>Responsitiver Slider Version: '.RSL_VERSION.'</h2>';	
		/******************************************************************************/  
		// Auswahl der Formulare
		/******************************************************************************/  
		switch($formular){
			case 'slider_verwaltung':
				require_once('formulare/wp-hb-slider-galerien.php');
			break;
			case 'slider_loeschen':
				require_once('formulare/wp-hb-slider-loeschen.php');
			break;
			case 'slider_uploader': 
				if ( isset( $_POST["slider_welcher"]) ) {
					$src = RSL_PLUGINDIR . 'js/wp-hb-uploader-ini.js'; // 	Full URL of the script
					$in_footer = true; // false ist der davault Wert 
					wp_enqueue_script('wp_hb_uploader', $src, '', RSL_VERSION, $in_footer);
					require_once('formulare/wp-hb-slider-uploader.php');
				}			
			default:
							
		}
		
	}
/***********************************************************/
/***********************************************************/
// Ab hier nun die Funktionen für dei Einbindung in TinyMCE
/***********************************************************/
/***********************************************************/

	// Eintragen der Styles in die editor-style.css
	/******************************************************************************/
	function TinyMCE_RSL_GALERIE_activate() 
	{
		$suche = '/****** für Responitiven Slider ******/';
		$l = strpos(getcwd(),"wp-admin");
		$dateiname_erg = substr(getcwd(),0,$l).'wp-content/plugins/wp-hb-slider/css/editor-style.css';
		$dateiname_org = get_stylesheet_directory().'/editor-style.css';
		
		if (file_exists($dateiname_erg)) 
        {
			$editor_style_erg =  file_get_contents ($dateiname_erg);
        }else
		{
			// wenn die Datei editor-style.css nicht  existier brauch auch nichts gemacht werden
			return;
		}
		
		
		if (file_exists($dateiname_org)) 
        {
			$editor_style_org =  file_get_contents ($dateiname_org);
        }
		
		$pos_org_1 = strpos($editor_style_org,$suche);
		$pos_org_2 = strrpos($editor_style_org,$suche) + strlen($suche );
		
		if ($pos_org_1 === false) 
		{ 			
			$editor_style_neu = '';
		}else
		{
			// lösche den Eintrag
			$l_org = $pos_org_2 - $pos_org_1;
			$editor_style_neu = substr_replace (  $editor_style_org , '' ,  $pos_org_1 ,  $l_org  );
			
		}
		
		// Neue Ergänzung an die Datei editor-style.css anhängen.
		file_put_contents (  $dateiname_org ,  $editor_style_erg , FILE_APPEND | LOCK_EX);
		// Kopiert das slidericon in den Themepfad
		$dateiname_icon_plugin = substr(getcwd(),0,$l).'wp-content/plugins/wp-hb-slider/css/rsl_icon64.png';
		$dateiname_icon_theme = get_stylesheet_directory().'/rsl_icon64.png';
		if (file_exists($dateiname_icon_plugin)) 
        {		
			copy($dateiname_icon_plugin, $dateiname_icon_theme); 
		}
   	}   
	/******************************************************************************/
	function TinyMCE_RSL_GALERIE_deactivate() 
	{
		$suche = '/****** für Responitiven Slider ******/';		
		
		$dateiname_org = get_stylesheet_directory().'/editor-style.css';
		$dateiname_icon_theme = get_stylesheet_directory().'/rsl_icon64.png';
		if (file_exists($dateiname_icon_theme)) 
        {
			unlink($dateiname_icon_theme);
        }
		
		
		if (file_exists($dateiname_org)) 
        {
			$editor_style_org =  file_get_contents ($dateiname_org);
        }
		$pos_org_1 = strpos($editor_style_org,$suche);
		$pos_org_2 = strrpos($editor_style_org,$suche) + strlen($suche );
		
		$l_org = $pos_org_2 - $pos_org_1;
		if ($pos_org_2 > 0) 
		{ 			
			// lösche den Eintrag
			$l_org = $pos_org_2 - $pos_org_1;
			
			$editor_style_neu = substr_replace (  $editor_style_org , '' ,  $pos_org_1 ,  $l_org  );
			file_put_contents (  $dateiname_org ,  $editor_style_neu );		
		}
		// setze die Datenbankversion auf 0 damit bei der nächsten Aktivierung garantiert die Datenbank überprüft wird.
		update_option( "RSL_db_version",'0.0.0' );
	}
	
	/*********************************************************************************************/	
	function rsl_setup_tinymce_plugin() 
	{ 
		// Prüfe ob der aktuelle Benutzer die Befugnis "edit Posts" oder "edit Pages" hat.
		// wenn nicht, wird unser TinyMCE plugin nicht registriert     
		if ( ! current_user_can( 'edit_posts' ) && ! current_user_can( 'edit_pages' ) ) 
		{
            return;
		} 
		// Prüfe ob der aktuelle Benutzer den Visual Editor benutzt.
		// wenn nicht, wird unser TinyMCE plugin nicht registriert
		if ( get_user_option( 'rich_editing' ) !== 'true' ) 
		{
			return;
		}
		// Wenn dem so ist setze ein paar Filter so dass wir das Plugin registrieren können.
		add_filter( 'mce_external_plugins', 'rsl_add_tinymce_plugin' ) ;
		add_filter( 'mce_buttons', 'rsl_add_tinymce_toolbar_button'  );
    }
	/*********************************************************************************************/	
	// Fügt eine TinyMCE plugin kompartibles JS file zur TinyMCE / Visual Editor instance	
	// @param array $plugin_array Array der registierten TinyMCE Plugins
	// @return array geändertes Array der registierten TinyMCE Plugins
	
	
	function rsl_add_tinymce_plugin( $plugin_array ) 
	{
		$plugin_array['wp_tinymce_slider_link'] = RSL_PLUGINDIR . 'js/wp-hb-slider-tinymce.js';
		return $plugin_array;
	}
	/*********************************************************************************************/	
	// Fügt einen button zun TinyMCE / Visual Editor den der Benutzer anklicken kann
	// um einen link mit eigener CSS class eun zu fügen.
	// @param array $buttons, Array der registierten TinyMCE Buttons
	// @return array, geändertes Array der registierten TinyMCE Buttons

	function rsl_add_tinymce_toolbar_button( $buttons ) 	{
		array_push( $buttons, '|', 'wp_tinymce_slider_link' );		
		return $buttons;
	}	
	
?>